---
title: La guerre des protocoles
date: 2020-11-30
author: raspbeguy
template: post
tags: tribune,protocole,web,xmpp,réseaux sociaux,xmpp,matrix
---

J'ai hésité à appeler cet article "_Oh putain c'qu'il est blèèèème, mon HTML_" mais j'ai eu peur que Renaud vienne m'apprendre un jeu rigolo à grand coup de chaîne de vélo.

Voici un recueil de mes propres opinions qui ont lentement muri face à la mode de la réinvention de la roue. Attention, ce n'est pas un phénomène nouveau. Cependant je pense que la dernière décennie, qui a vu l'âge de la puberté d'Internet (car à mon avis Internet n'est toujours pas à l'âge adulte) a été l'occasion pour beaucoup de personnes de remettre en question des éléments essentiels de cet outil.


# La diversité c'est bien au niveau microscopique...

Qu'on se le dise : la diversité des technologies, c'est plutôt une bonne chose, en général. Cela permet de découper les piles technologiques en segments atomiques (une techno par tâche simple) et ainsi, si on n'est pas satisfait du résultat d'une techno, on la change, ou mieux, on la subdivise encore.

Prenons un exemple pratique : Hastagueule, comme la plupart des sites, est composé de 3 "briques" : un frontal, une application, un dépôt de données.

Il y a très longtemps, Apache2 s'occupait à la fois du frontal HTTP et de l'interpréteur pour l'application (Wordpress, en PHP). La pile était donc la suivante :

- Frontal (+ interpréteur application) : Apache2
- Application : Wordpress
- Dépôt de données : MySQL

Plus tard, j'ai scindé cette tâche : j'ai utilisé nginx pour faire frontal, et php-fpm pour l'interpréteur. Ensuite, j'ai changé de base de donnée en passant de MySQL à MariaDB. Plus récemment, j'ai décidé de me passer de Wordpress et de paccer à [PicoCMS](edito-11-refonte-en-profondeur) et du coup de me débarasser de la base de donnée en passant par des données en fichier texte brut, versionnées par git.

La nouvelle pile est devenue la suivante :

- Frontal : Nginx
- Interpréteur application : php-fpm
- Application : PicoCMS
- Dépôt de données : dossier versionné par git

Les briques ont pu la plupart du temps être changées sans altérer le résultat produit. Bien entendu, le changement d'application, lui, a été disruptif et a impliqué de changer le système de données également, mais cela était justement désiré.

# ... mais peut poser problème au niveau macroscopique !

On parle maintenant au niveau plus global qui est l'usage que l'on fait des piles de technologies.

Internet est un outil de communication. Des gens diffusent des contenus et se parlent entre eux. Comme dans la vie normale donc, il y a des codes, des conventions, des règles, des habitudes.

Pour que les gens gardent le fil de leur vie personnelle, ils ont tendance à adopter un nombre très limité d'outils pour s'informer et communiquer. La diversité sauvage et non coordonnée, à ce niveau, crée donc immanquablement un cloisonnement de groupes d'utilisateurs. À moins que des passerelles simples et attrayantes soient disponibles, les utilisateurs sont donc contraints à multiplier les outils pour leur survie numérique.

Chacun est libre d'utiliser ce qu'il veut, en particulier lorsqu'il est le seul impacté par ses choix. Mais avant de recréer un outil à destination d'utilisateurs finaux, il faut vraiment bien estimer la légitimité et les implications de cette action. En ce qui me concerne, une raison qui rend cette action légitime à coup sûr, c'est l'absence d'autres projets libres remplissant cette fonction.

## Gemini

[Gemini](https://gemini.circumlunar.space/) est l'élément déclencheur qui m'a amené à écrire cet article.

Au début des années 90, alors qu'Internet n'est utilisé que par une minorité d'universitaires boutonneux pour faire des truc d'intello, on voit naître à peu près simultanément au moins deux technologies de récupérer des informations navigables, sous formes d'index et de pages : HTTP en Europe, et Gopher en Amérique. Ces deux technologies vont se développer en parallèle et donner deux facettes de l'Internet navigable, celle d'HTTP sera appelée le Web. Après seulement quelques années, Gopher finit par se faire manger par HTTP pour être réduit à peau de chagrin.

Je ne vais pas taper sur Gopher. Ce protocole a au moins la légitimité d'être né en même temps que le web. Cependant, son déclin est en partie lié à son austérité.

# Navigation
